Rem GPU bezier/arc/ellipse tester written in 'FreeBasic'
REM Setup by Brian Guralnick
REM 
REM Get the freeBasic compiler at 
REM 
REM 

Declare Sub draw_pixel(xp as integer, yp as integer, colr as Ubyte, colg as Ubyte, colb as Ubyte)  : REM Draws 1 dot with paleted Color
Declare Sub drawLine(x1 as integer, y1 as integer, x2 as integer, y2 As Integer, cr As Ubyte, cg As Ubyte, cb As Ubyte)
Declare Sub draw_ellipse(ByVal xc As integer, ByVal yc As Integer, ByVal a As integer, ByVal b As Integer)
Declare Sub drawArc (inv As Boolean, quadrant As Integer, a As Integer, b As Integer, xc As Integer, yc As Integer, cr As Integer, cg As Integer, cb As Integer)

Dim Shared as Integer mx,mxl,my,myl,mb,mbl,mw,mwl,sx,sy,dx,dy,dz
Dim Shared as Integer destmem, srcmem, max_x,max_y, src_width, dest_width
Dim Shared as Ubyte   show_pset
Dim Shared as String ink

ScreenRes 720,560,16,0,0 : REM open a window a little larger than 640x480

Rem *************************************************************
REM **** Loop drawing the ellipse using the mouse choordinates **
REM **** Use the ESC key to quit **
REM *************************************************************

ink=""
while ink<>chr(27)

getmouse mx,my,mw,mb
mx=mx-8
my=my-8

            If mx<>mxl or my<>myl or mb<>mbl then
               
               line (0,0)-(719,559),rgb( 0,0,0 ),BF : rem rem cls fast

               sx = 320
               sy = 240
               dx = (mx-320)/1 : if dx<0 then dx=0
               dy = (240-my)/1 : if dy<0 then dy=0

              REM These coordinates define points P0,P1,P2 for a Bzier curve top left side
               drawLine (sx,sy,mx,my,128,96,64) 
               drawLine (sx,sy,320,my,128,96,64) 
               drawLine (sx,sy,mx,240,128,96,64) 
               rem Drawline as a line 
               draw_ellipse (sx,sy,dx,dy) 
               rem Drawline as an arc
 
               mxl=mx:myl=my:mbl=mb:mw=mwl : rem store old mouse state

               color rgb(255,255,255),rgb(0,0,0)
               locate 69,1
               ? " coord 1ab  (";sx;",";sy;")-(";dx;",";dy;")        "
                
            End if

sleep 1: rem wait for a keypress before quitting
ink=inkey
wend
end

REM *************************************************************
REM **** Draw LINE-ARC with the palette color ************
REM *************************************************************
Sub draw_ellipse (ByVal xc As integer, ByVal yc As Integer, ByVal a As integer, ByVal b As Integer)
	
   Dim As Integer cr, cg, cb=0, quad
	
	'For quad=0 To 3
		cr=0:cg=255
   	drawArc (true, quad, a, b, xc, yc, cr, cg, cb)
   	cr=255:cg=0
	'	drawArc (true, quad, a, b, xc, yc, cr, cg, cb)
	'Next quad
	
End Sub

Sub drawArc (inv As Boolean, quadrant As Integer, ByVal a As Integer, ByVal b As Integer, ByVal xc As Integer, ByVal yc As Integer, ByVal cr As Integer, ByVal cg As Integer, ByVal cb As Integer)
	
   Dim As Integer b1, x1,y1,x0,y0,a1 : Rem values of diameter
   Dim As Integer dx , dy : Rem error increment
   Dim As Integer errd,e2 : Rem error of 1.step

xc=xc-a
yc=yc-b
a=a*2
b=b*2

   b1 = b And 1

x1=a
y1=b
x0=0
y0=0


dx   = 4*(1-a)*b*b
dy   = 4*(b1+1)*a*a
errd = dx + dy + b1 * a * a


   y0 = y0 + (b + 1) / 2
   y1 = y0 - b1 : Rem starting pixel
   a = a*(8*a)
   b1 = 8*b*b

   While (x0 <= x1)

      draw_pixel(xc+x1, yc+y1, cr,cg,cb) : Rem   IV. Quadrant


      e2 = 2*errd
      If (e2 <= dy) Then
       	y0 = y0 + 1
       	y1 = y1 - 1
       	dy = dy + a
       	errd = errd + dy : rem  y Step
      End If
      If (e2 >= dx Or (2*errd) > dy) Then
       	x0 = x0 + 1
       	x1 = x1 - 1
       	dx = dx + b1
       	errd = errd + dx : rem x Step
      End If
   Wend
 
   While (y0 - y1 < b)  : Rem too early stop of flat ellipses a=1
      draw_pixel(xc, yc+y1, cr,cg,cb) : Rem   IV. Quadrant
       y0 = y0 + 1
       y1 = y1 - 1
   Wend

End Sub

REM *************************************************************
REM **** Draw Line Using Bresenham's algorithm ************
REM *************************************************************
Sub drawLine (ByVal x0 as Integer, byval y0 as Integer, byval x1 as Integer, byval y1 as Integer, byval cr As UByte, byval cg As UByte, byval cb As UByte) 
   Dim As integer  dx,dy,x,y,sx,sy,errd,magic
   Dim As boolean is_done

   Rem bounding box's width and height
   Rem set the loop's sign
   dx = x1 - x0
   dy = y1 - y0
    
   If (dx < 0) Then
      dx = -dx
      sx = -1
   Else
      sx = 1
   End If
    
   If (dy > 0) Then
      dy = -dy
      sy = 1
   Else
   	sy = -1
   End If

   magic = 0
   errd  = dx + dy
   x     = x0
   y     = y0
   is_done = FALSE
    
   While (is_done = False)
		
      draw_pixel (x,y,cr,cg,cb)
		
      Rem Reached the End
      If (x = x1 And y = y1) Then
      	is_done = TRUE
      Else
      	is_done = FALSE
      End If
		
      Rem Loop carried
      magic = errd shl 1
      if (magic > dy) Then
         errd += dy
         x    += sx
      End If
        
      if (magic < dx) Then
         errd += dx
         y    += sy
      End If
   Wend

End Sub

REM *************************************************************
REM **** Draw a dot with the palette color ************
REM *************************************************************
Sub draw_pixel(xp as integer, yp as integer, colr as Ubyte, colg as Ubyte, colb as Ubyte)
	PSet ( xp,yp ),rgb( colr,colg,colb )
end sub
